diff -ruN strongswan-5.8.4/src/libstrongswan/networking/streams/stream_service_unix.c strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_service_unix.c
--- strongswan-5.8.4/src/libstrongswan/networking/streams/stream_service_unix.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_service_unix.c	2022-07-08 11:41:12.759409000 +0300
@@ -18,9 +18,103 @@
 
 #include <errno.h>
 #include <unistd.h>
+#ifndef WIN32
 #include <sys/socket.h>
 #include <sys/un.h>
 #include <sys/stat.h>
+#else
+#include <windows.h>
+#include <accctrl.h>
+#include <aclapi.h>
+#endif
+
+bool change_owner(int fd, struct sockaddr_un *addr)
+{
+#ifdef WIN32
+    /* Change owner of socket */
+    /* https://docs.microsoft.com/en-us/windows/win32/secauthz/taking-object-ownership-in-c-- */
+	SECURITY_DESCRIPTOR *security_descriptor = malloc(SECURITY_DESCRIPTOR_MIN_LENGTH);
+	SECURITY_ATTRIBUTES security_attributes = {
+		.nLength = sizeof(SECURITY_ATTRIBUTES),
+		.bInheritHandle = FALSE,
+	};;
+	PACL pACL = NULL;
+	EXPLICIT_ACCESS ea[2];
+	SID *pAdminSID = NULL;
+	SID_IDENTIFIER_AUTHORITY SIDAuthNT = SECURITY_NT_AUTHORITY;
+
+	char buf[512];
+	int ret;
+        /* BUILTIN\Administrator  */
+	if(!AllocateAndInitializeSid(&SIDAuthNT, 2,
+                     SECURITY_BUILTIN_DOMAIN_RID,
+                     DOMAIN_ALIAS_RID_ADMINS,
+                     0, 0, 0, 0, 0, 0,
+                     (void **) &pAdminSID)) 
+	{
+		DBG1(DBG_LIB, "Failed to initialize SID: %s", dlerror_mt(buf, sizeof(buf)));
+		goto cleanup;
+	}
+
+	memset(ea, 0, sizeof(EXPLICIT_ACCESS));
+	ea[0].grfAccessPermissions = KEY_ALL_ACCESS;
+	ea[0].grfAccessMode = SET_ACCESS;
+	ea[0].grfInheritance= NO_INHERITANCE;
+	ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
+	ea[0].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
+	ea[0].Trustee.ptstrName  = (LPTSTR) pAdminSID;
+	if (!InitializeSecurityDescriptor(security_descriptor, SECURITY_DESCRIPTOR_REVISION))
+	{
+		DBG1(DBG_LIB, "Failed to initialize security descriptor: %s", dlerror_mt(buf, sizeof(buf)));
+		goto cleanup;
+	}
+	if ((ret=SetEntriesInAcl(1, ea, NULL, &pACL)) != ERROR_SUCCESS)
+	{
+		DBG1(DBG_LIB, "Failed to set ACL entries: %s", human_readable_error(buf, ret, sizeof(buf)));
+		goto cleanup;		
+	}
+	if ((ret=SetSecurityDescriptorDacl(security_descriptor, TRUE, pACL, FALSE)))
+	{
+		DBG1(DBG_LIB, "Failed to set security descriptor in ACL: %s", dlerror_mt(buf, sizeof(buf)));
+		goto cleanup;
+	}
+	security_attributes.lpSecurityDescriptor = security_descriptor; 
+
+        if(SetNamedSecurityInfo(
+        addr->sun_path,
+        SE_FILE_OBJECT,
+        DACL_SECURITY_INFORMATION,
+        NULL, NULL,                  
+        pACL,                        
+        NULL))
+        {
+            ret = TRUE;
+        }
+        
+cleanup:
+        FreeSid(pAdminSID);
+        return ret;
+#else
+	if (lib->caps->check(lib->caps, CAP_CHOWN))
+	{
+		if (chown(addr->sun_path, lib->caps->get_uid(lib->caps),
+				  lib->caps->get_gid(lib->caps)) != 0)
+		{
+			DBG1(DBG_NET, "changing socket owner/group for '%s' failed: %s",
+				 uri, strerror(errno));
+		}
+	}
+	else
+	{
+		if (chown(addr->sun_path, -1, lib->caps->get_gid(lib->caps)) != 0)
+		{
+			DBG1(DBG_NET, "changing socket group for '%s' failed: %s",
+				 uri, strerror(errno));
+		}
+	}
+        return TRUE;
+#endif
+}
 
 /**
  * See header
@@ -64,22 +158,9 @@
 	 * dropping caps. This requires the user that charon starts as to:
 	 * a) Have write access to the socket dir.
 	 * b) Belong to the group that charon will run under after dropping caps. */
-	if (lib->caps->check(lib->caps, CAP_CHOWN))
-	{
-		if (chown(addr.sun_path, lib->caps->get_uid(lib->caps),
-				  lib->caps->get_gid(lib->caps)) != 0)
-		{
-			DBG1(DBG_NET, "changing socket owner/group for '%s' failed: %s",
-				 uri, strerror(errno));
-		}
-	}
-	else
+	if (!change_owner(fd, &addr))
 	{
-		if (chown(addr.sun_path, -1, lib->caps->get_gid(lib->caps)) != 0)
-		{
-			DBG1(DBG_NET, "changing socket group for '%s' failed: %s",
-				 uri, strerror(errno));
-		}
+		DBG1(DBG_NET, "Failed to change owner of socket '%s': %s", uri, strerror(errno));
 	}
 	if (listen(fd, backlog) < 0)
 	{
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/streams/stream_unix.h strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_unix.h
--- strongswan-5.8.4/src/libstrongswan/networking/streams/stream_unix.h	2016-04-22 23:01:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_unix.h	2022-07-08 11:41:11.295378000 +0300
@@ -21,7 +21,9 @@
 #ifndef STREAM_UNIX_H_
 #define STREAM_UNIX_H_
 
+#ifndef WIN32
 #include <sys/un.h>
+#endif
 
 /**
  * Create a stream for UNIX sockets.
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/tun_device.c strongswancont-5.8.4-svc/src/libstrongswan/networking/tun_device.c
--- strongswan-5.8.4/src/libstrongswan/networking/tun_device.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/tun_device.c	2020-11-30 16:52:55.000000000 +0300
@@ -26,7 +26,9 @@
 #if !TARGET_OS_OSX
 #define TUN_DEVICE_NOT_SUPPORTED
 #endif
-#elif !defined(__linux__) && !defined(HAVE_NET_IF_TUN_H)
+#endif
+
+#if ! (defined(__linux__) || defined(HAVE_NET_IF_TUN_H) || defined(USE_WINTUN))
 #define TUN_DEVICE_NOT_SUPPORTED
 #endif
 
@@ -42,15 +44,14 @@
 
 #include <errno.h>
 #include <fcntl.h>
-#include <netinet/in.h>
 #include <string.h>
-#include <sys/ioctl.h>
 #include <sys/types.h>
-#include <sys/socket.h>
 #include <sys/stat.h>
 #include <unistd.h>
+#include <sys/ioctl.h>
+#include <netinet/in.h>
+#include <sys/socket.h>
 #include <net/if.h>
-
 #ifdef __APPLE__
 #include <net/if_utun.h>
 #include <netinet/in_var.h>
@@ -65,7 +66,6 @@
 #else
 #include <net/if_tun.h>
 #endif
-
 #define TUN_DEFAULT_MTU 1500
 
 typedef struct private_tun_device_t private_tun_device_t;
@@ -83,14 +83,13 @@
 	int tunfd;
 
 	/**
-	 * Name of the TUN device
-	 */
-	char if_name[IFNAMSIZ];
-
-	/**
 	 * Socket used for ioctl() to set interface addr, ...
 	 */
 	int sock;
+	/**
+	 * Name of the TUN device
+	 */
+	char if_name[IFNAMSIZ];
 
 	/**
 	 * The current MTU
@@ -222,31 +221,8 @@
 		return FALSE;
 	}
 	return TRUE;
-}
 
 #endif /* __FreeBSD__ */
-
-METHOD(tun_device_t, set_address, bool,
-	private_tun_device_t *this, host_t *addr, uint8_t netmask)
-{
-	if (!set_address_impl(this, addr, netmask))
-	{
-		return FALSE;
-	}
-	DESTROY_IF(this->address);
-	this->address = addr->clone(addr);
-	this->netmask = netmask;
-	return TRUE;
-}
-
-METHOD(tun_device_t, get_address, host_t*,
-	private_tun_device_t *this, uint8_t *netmask)
-{
-	if (netmask && this->address)
-	{
-		*netmask = this->netmask;
-	}
-	return this->address;
 }
 
 METHOD(tun_device_t, up, bool,
@@ -315,12 +291,35 @@
 	return this->mtu;
 }
 
+
+METHOD(tun_device_t, set_address, bool,
+	private_tun_device_t *this, host_t *addr, uint8_t netmask)
+{
+	if (!set_address_impl(this, addr, netmask))
+	{
+		return FALSE;
+	}
+	DESTROY_IF(this->address);
+	this->address = addr->clone(addr);
+	this->netmask = netmask;
+	return TRUE;
+}
+
+METHOD(tun_device_t, get_address, host_t*,
+	private_tun_device_t *this, uint8_t *netmask)
+{
+	if (netmask && this->address)
+	{
+		*netmask = this->netmask;
+	}
+	return this->address;
+}
+
 METHOD(tun_device_t, get_name, char*,
 	private_tun_device_t *this)
 {
 	return this->if_name;
 }
-
 METHOD(tun_device_t, get_fd, int,
 	private_tun_device_t *this)
 {
@@ -330,8 +329,7 @@
 METHOD(tun_device_t, write_packet, bool,
 	private_tun_device_t *this, chunk_t packet)
 {
-	ssize_t s;
-
+        ssize_t s;
 #ifdef __APPLE__
 	/* UTUN's expect the packets to be prepended by a 32-bit protocol number
 	 * instead of parsing the packet again, we assume IPv4 for now */
@@ -408,12 +406,9 @@
 	free(this);
 }
 
-/**
- * Initialize the tun device
- */
-static bool init_tun(private_tun_device_t *this, const char *name_tmpl)
+bool init_tun(private_tun_device_t *this, const char *name_tmpl)
 {
-#ifdef __APPLE__
+#if defined(__APPLE__)
 
 	struct ctl_info info;
 	struct sockaddr_ctl addr;
@@ -533,8 +528,7 @@
 		DBG1(DBG_LIB, "failed to open %s: %s", this->if_name, strerror(errno));
 	}
 	return this->tunfd > 0;
-
-#endif /* !__APPLE__ */
+#endif
 }
 
 /*
@@ -543,7 +537,7 @@
 tun_device_t *tun_device_create(const char *name_tmpl)
 {
 	private_tun_device_t *this;
-
+	
 	INIT(this,
 		.public = {
 			.read_packet = _read_packet,
@@ -567,7 +561,6 @@
 		return NULL;
 	}
 	DBG1(DBG_LIB, "created TUN device: %s", this->if_name);
-
 	this->sock = socket(AF_INET, SOCK_DGRAM, 0);
 	if (this->sock < 0)
 	{
@@ -577,5 +570,4 @@
 	}
 	return &this->public;
 }
-
 #endif /* TUN devices supported */
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/tun_device.h strongswancont-5.8.4-svc/src/libstrongswan/networking/tun_device.h
--- strongswan-5.8.4/src/libstrongswan/networking/tun_device.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/tun_device.h	2020-11-30 16:52:55.000000000 +0300
@@ -25,6 +25,9 @@
 
 #include <networking/host.h>
 
+#ifdef WIN32
+#include "windows_tun.h"
+#else
 typedef struct tun_device_t tun_device_t;
 
 /**
@@ -121,4 +124,5 @@
  */
 tun_device_t *tun_device_create(const char *name_tmpl);
 
+#endif /* !WIN32 */
 #endif /** TUN_DEVICE_H_ @}*/
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/windows_tun.c strongswancont-5.8.4-svc/src/libstrongswan/networking/windows_tun.c
--- strongswan-5.8.4/src/libstrongswan/networking/windows_tun.c	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/windows_tun.c	2022-12-08 15:27:25.366556000 +0300
@@ -0,0 +1,347 @@
+/*
+ * Copyright (C) 2020 Noel Kuntze <noel.kuntze@thermi.consulting>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <winsock2.h>
+#include <windows.h>
+#include <cfgmgr32.h>
+#include <setupapi.h>
+#include <devpkey.h>
+#include <winreg.h>
+#include <utils/windows_helper.h>
+#include <ddk/ndisguid.h>
+
+#include <string.h>
+
+#include "../utils/utils/memory.h"
+#include "../collections/linked_list.h"
+
+#include "windows_tun.h"
+#include "wintun_support.h"
+
+/* Stub. */
+struct private_openvpn_tun_device_t {
+} typedef private_openvpn_tun_device_t;
+
+ /*
+ * Helper function to get the next HardwareID in the
+ * SP_DRVINFO_DETAIL_DATA_A.HardwareID linear array.
+ * (Looks like this: "abcdef\0ghijkl\0mnopqrs\0\0". Empty string (Just a NULL byte)
+ * denotes the end of the array)
+ *
+ * @param pile			linear character array of the hardwareIDs as they are part of
+ *						the SP_DRVINFO_DETAIL_DATA_A struct.
+ * @param offset		pointer to a location in which the end position of the search algorithm is stored.
+ *						It is used to keep the offset between multiple calls of the function and ease its use.
+ *						The value is the position at which the resulting string ends (strlen() + 1, or its NULL byte)
+ * @return				The next hardwareID or NULL, if the end of the array was reached.
+ */
+char *windows_drv_info_get_next_hardwareid(char *pile, size_t *offset)
+{
+	size_t len = 0, old_offset = 0;
+	old_offset = *offset;
+	len = strlen(pile + *offset);
+	*offset += len + 1;
+	if (len == 0)
+	{
+		/* End of the list, empty string. */
+		return NULL;
+	}
+	return pile + old_offset;
+}
+
+/*
+ * Wide string version of windows_drv_info_get_next_hardwareid 
+ */
+/*
+wchar_t *windows_drv_info_get_next_hardwareid_wide(wchar_t *pile, size_t *offset)
+{
+	size_t len = 0, old_offset = 0;
+	while(true)
+	{
+		old_offset = *offset;
+		len = wcslen(pile + *offset);
+		*offset += len + sizeof(wchar_t);
+		if (len == 0)
+		{
+			End of the list, empty string. 
+			return NULL;
+		}
+		return pile + old_offset;
+	}
+}
+*/
+
+/*
+ * Helper function that wraps around windows_drv_info_get_next_hardwareid.
+ * It returns true if needle is in the pile (pile is a linear, empty string terminated array of strings).
+ * It returns false if needle is NOT in the pile.
+ *
+ * @param pile			A linear array of strings. Terminated by an empty string.
+ * @param needle		A string to find in pile.
+ *
+ * @returns				Returns whether needle is in pile
+ */
+bool find_matching_hardwareid(char *pile, char* needle)
+{
+	size_t offset = 0;
+	char *item;
+	while(true)
+	{
+		item = windows_drv_info_get_next_hardwareid(pile, &offset);
+		if (!item)
+		{
+			return false;
+		}
+
+		if(!strcmp(item, needle))
+		{
+			return true;
+		}
+	}
+	return false;
+}
+/*
+ * Wide version of find_matching_hardwareid
+ */
+/*
+bool find_matching_hardwareid_wide(wchar_t *pile, wchar_t* needle)
+{
+	size_t offset = 0;
+	wchar_t *item;
+	while(true)
+	{
+		item = windows_drv_info_get_next_hardwareid_wide(pile, &offset);
+		DBG0(DBG_LIB, "next hardwareID: %ls", item);
+		if (!item)
+		{
+			return false;
+		}
+
+		if(wcscmp(item, needle) == 0)
+		{
+			return true;
+		}
+	}
+}
+*/
+
+char *windows_setupapi_get_friendly_name(char *buffer, size_t buf_len, HDEVINFO dev_info_set,
+										 SP_DEVINFO_DATA *dev_info_data)
+{
+	memwipe(buffer, buf_len);
+	size_t required_length;
+	DWORD prop_type;
+	char buf[512];
+
+	if (!SetupDiGetDeviceRegistryPropertyA(
+		dev_info_set, dev_info_data,
+		SPDRP_DEVICEDESC,
+		&prop_type,
+		buffer,
+		buf_len,
+		(DWORD *)&required_length))
+	{
+		if (!SetupDiGetDeviceRegistryPropertyA(
+			dev_info_set, dev_info_data,
+			SPDRP_FRIENDLYNAME,
+			&prop_type,
+			buffer,
+			buf_len,
+			(DWORD *)&required_length))
+		{
+			// Try hardware path instead 
+			if (SetupDiGetDeviceRegistryPropertyA(
+				dev_info_set, dev_info_data,
+				SPDRP_LOCATION_INFORMATION,
+				&prop_type,
+				buffer,
+				buf_len,
+				(DWORD *)&required_length))
+			{
+				if (strcmp(buffer, "\r\n") || strcmp(buffer, ""))
+				{
+					ignore_result(snprintf(buffer, buf_len, "<unknown>"));
+				}
+				return buffer;
+			}
+			else
+			{
+				DBG2(DBG_LIB, "Failed to retrieve the hardware location of a device: %s", dlerror_mt(buf, sizeof(buf)));
+			}
+		}
+	}
+	return buffer;
+}
+
+/*
+bool windows_get_driver_info_data_a(
+	HDEVINFO *dev_info_set,
+	SP_DEVINFO_DATA *dev_info_data,
+	SP_DRVINFO_DATA_A *drv_info_data,
+	PSP_DRVINFO_DETAIL_DATA_A *drv_info_detail_data,
+	DWORD *property_buffer_length,
+	DWORD *required_length
+)
+{
+	DWORD error, ret;
+	char buf[512];
+	while(TRUE)
+	{
+	if (!(ret=SetupDiGetDriverInfoDetailA(
+		*dev_info_set,
+		dev_info_data,
+		drv_info_data,
+		*drv_info_detail_data,
+		*property_buffer_length,
+		required_length
+	)))
+	{
+		error = GetLastError();
+		switch (error) {
+			case 0:
+				break;
+			case ERROR_INVALID_USER_BUFFER:
+				DBG1(DBG_LIB, "Error %d: Insufficient memory.", error);
+				// allocate memory
+				*drv_info_detail_data = realloc(
+					*drv_info_detail_data,
+					*required_length + sizeof(SP_DRVINFO_DETAIL_DATA_A));
+				(*drv_info_detail_data)->cbSize = sizeof(SP_DRVINFO_DETAIL_DATA_A);
+				*property_buffer_length = *required_length + sizeof(SP_DRVINFO_DETAIL_DATA_A);
+				DBG0(DBG_LIB, "required_length: %u", *required_length);
+				if (!SetupDiGetDriverInfoDetailA(
+					*dev_info_set,
+					dev_info_data,
+					drv_info_data,
+					*drv_info_detail_data,
+					*property_buffer_length,
+					required_length
+				))
+				{
+					error = GetLastError();
+					DBG1(DBG_LIB,
+						"Previous required length was bogus. New error is %d: %s",
+						error, dlerror_mt(buf, sizeof(buf)));
+				}
+				break;
+			case ERROR_INSUFFICIENT_BUFFER:
+				DBG1(DBG_LIB, "Invalid user buffer (for some reason) %d", error);
+				return FALSE;
+				break;
+			default:
+				DBG1(DBG_LIB, "A different error occured %d: %s",
+				 error, dlerror_mt(buf, sizeof(buf)));
+				return FALSE;
+				break;
+		}
+	} else {
+		DBG1(DBG_LIB, "Received error: %s", dlerror_mt(buf, sizeof(buf)));
+	}
+	}
+	return FALSE;
+} */
+
+bool check_hardwareids(SP_DRVINFO_DETAIL_DATA_A *drv_info_detail_data)
+{
+	/* Make sure CompatIDsOffset indicates more than one HardwareID is in it
+	 * but also there actually is a hardware ID in the HardwareID field,
+	 * instead of just a \r(\n) (Windows DOES do that!) */
+	if (drv_info_detail_data->CompatIDsOffset > 1 &&
+		drv_info_detail_data->HardwareID &&
+		drv_info_detail_data->HardwareID[0] != '\r')
+	{
+		DBG2(DBG_LIB, "HardwareID: %%s",
+			drv_info_detail_data->HardwareID);
+		if (!strcmp(
+			drv_info_detail_data->HardwareID,
+			WINTUN_COMPONENT_ID)) {
+			/* HardwareID matches */
+			DBG2(DBG_LIB, "HardwareID %s matches %s",
+				drv_info_detail_data->HardwareID,
+				WINTUN_COMPONENT_ID);
+			return TRUE;
+		} else {
+			DBG2(DBG_LIB, "HardwareID does not match");
+			return FALSE;
+		}
+	}
+	// Iterate over HardwareID array in drv_info_detail_data
+	if(!(WINDOWS_IS_UNITIALIZED(drv_info_detail_data->CompatIDsOffset)) &&
+		drv_info_detail_data->CompatIDsLength > 0)
+	{	
+		DBG2(DBG_LIB, "HardwareID: %hs", drv_info_detail_data->HardwareID);
+		/* compatIDs are in wide characters. Need to convert all fields into compatible */
+		if(find_matching_hardwareid(
+			drv_info_detail_data->HardwareID,
+			(char *) WINTUN_COMPONENT_ID))
+		{
+			return TRUE;			
+		} else {
+			DBG2(DBG_LIB, "ID %s is not in compatible hardware IDs", WINTUN_COMPONENT_ID);
+			return FALSE;
+		}
+	}
+	return FALSE;
+}
+
+/* Described in header */
+linked_list_t *string_array_to_linked_list(char *pile)
+{
+	linked_list_t *list = linked_list_create();
+	size_t offset = 0;
+	char *item;
+	while(true)
+	{
+		item = windows_drv_info_get_next_hardwareid(pile, &offset);
+		if (!item)
+		{
+			return list;
+		}
+		list->insert_last(list, item);
+	}
+	return list;
+}
+
+/* Stub */
+tun_device_t *try_configure_openvpn(const char *name_tmpl)
+{
+	return NULL;
+}
+/*
+ * Described in header
+ */
+
+tun_device_t *tun_device_create(const char *name_tmpl)
+{
+		tun_device_t *public = NULL;
+#ifdef USE_WINTUN
+	public = try_configure_wintun(name_tmpl);
+	/* if (!public)
+	{
+		public = try_configure_openvpn(name_tmpl);
+	} */
+	if(!public)
+	{
+		DBG0(DBG_LIB, "failed to create TUN device.");
+		return NULL;
+	}
+	DBG0(DBG_LIB, "created TUN device: %s", public->get_name(public));
+#else
+	DBG1(DBG_LIB, "TUN devices are not supported");
+#endif
+	return public;
+}
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/windows_tun.h strongswancont-5.8.4-svc/src/libstrongswan/networking/windows_tun.h
--- strongswan-5.8.4/src/libstrongswan/networking/windows_tun.h	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/windows_tun.h	2020-11-30 16:52:55.000000000 +0300
@@ -0,0 +1,186 @@
+/*
+ * Copyright (C) 2020 Noel Kuntze <noel.kuntze@thermi.consulting>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/* 
+ * File:   windows_tun.h
+ * Author: thermi
+ *
+ * Created on 27. April 2020, 14:58
+ */
+
+#ifndef WINDOWS_TUN_H
+#define WINDOWS_TUN_H
+
+typedef struct tun_device_t tun_device_t;
+
+#ifdef USE_WINTUN
+#include "wintun_support.h"
+#endif
+
+/**
+ * Class to create TUN devices
+ *
+ * Creating such a device requires the CAP_NET_ADMIN capability.
+ */
+struct tun_device_t {
+
+	/**
+	 * Read a packet from the TUN device
+	 *
+	 * @note This call blocks until a packet is available. It is a thread
+	 * cancellation point.
+	 *
+	 * @param packet		the packet read from the device, allocated
+	 * @return				TRUE if successful
+	 */
+	bool (*read_packet)(tun_device_t *this, chunk_t *packet);
+
+	/**
+	 * Write a packet to the TUN device
+	 *
+	 * @param packet		the packet to write to the TUN device
+	 * @return				TRUE if successful
+	 */
+	bool (*write_packet)(tun_device_t *this, chunk_t packet);
+
+	/**
+	 * Set the IP address of the device
+	 *
+	 * @param addr			the desired interface address
+	 * @param netmask		the netmask to use
+	 * @return				TRUE if operation successful
+	 */
+	bool (*set_address)(tun_device_t *this, host_t *addr, uint8_t netmask);
+
+	/**
+	 * Get the IP address previously assigned to using set_address().
+	 *
+	 * @param netmask		pointer receiving the configured netmask, or NULL
+	 * @return				address previously set, NULL if none
+	 */
+	host_t* (*get_address)(tun_device_t *this, uint8_t *netmask);
+
+	/**
+	 * Bring the TUN device up
+	 *
+	 * @return				TRUE if operation successful
+	 */
+	bool (*up)(tun_device_t *this);
+
+	/**
+	 * Set the MTU for this TUN device
+	 *
+	 * @param mtu			new MTU
+	 * @return				TRUE if operation successful
+	 */
+	bool (*set_mtu)(tun_device_t *this, int mtu);
+
+	/**
+	 * Get the current MTU for this TUN device
+	 *
+	 * @return				current MTU
+	 */
+	int (*get_mtu)(tun_device_t *this);
+
+	/**
+	 * Get the interface name of this device
+	 *
+	 * @return				interface name
+	 */
+	char *(*get_name)(tun_device_t *this);
+
+	/**
+	 * Get the underlying HANDLE.
+	 *
+	 * @return                              file HANDLE of this tun device
+	 */
+	HANDLE (*get_handle)(tun_device_t *this);
+
+	/**
+	 * Destroy a tun_device_t
+	 */
+	void (*destroy)(tun_device_t *this);
+
+};
+
+ /*
+ * Helper function to get the next HardwareID in the
+ * SP_DRVINFO_DETAIL_DATA_A.HardwareID linear array.
+ * (Looks like this: "abcdef\0ghijkl\0mnopqrs\0\0". Empty string (Just a NULL byte)
+ * denotes the end of the array)
+ *
+ * @param pile			linear character array of the hardwareIDs as they are part of
+ *						the SP_DRVINFO_DETAIL_DATA_A struct.
+ * @param offset		pointer to a location in which the end position of the search algorithm is stored.
+ *						It is used to keep the offset between multiple calls of the function and ease its use.
+ *						The value is the position at which the resulting string ends (strlen() + 1, or its NULL byte)
+ * @return				The next hardwareID or NULL, if the end of the array was reached.
+ */
+char *windows_drv_info_get_next_hardwareid(char *pile, size_t *offset);
+
+/*
+ * Helper function that wraps around windows_drv_info_get_next_hardwareid.
+ * It returns true if needle is in the pile (pile is a linear, empty string terminated array of strings).
+ * It returns false if needle is NOT in the pile.
+ *
+ * @param pile			A linear array of strings. Terminated by an empty string.
+ * @param needle		A string to find in pile.
+ *
+ * @return				Returns whether needle is in pile
+ */
+bool find_matching_hardwareid(char *pile, char* needle);
+
+/*
+ * Helper function for getting a nice human readable name for a specific device.
+ * @param buffer                Allocated buffer that receives the device name.
+ * @param buf_len               Length of the buffer in bytes.
+ * @param dev_info_set          device info set that contains the device
+ * @param dev_info_data         Data
+ * @return                      zero byte terminated friendly name. Same as buffer.
+ */
+char *windows_setupapi_get_friendly_name(char *buffer, size_t buf_len, HDEVINFO dev_info_set, SP_DEVINFO_DATA *dev_info_data);
+
+/*
+bool windows_get_driver_info_data_a(
+	HDEVINFO *dev_info_set,
+	SP_DEVINFO_DATA *dev_info_data,
+	SP_DRVINFO_DATA_A *drv_info_data,
+	PSP_DRVINFO_DETAIL_DATA_A *drv_info_detail_data,
+	DWORD *property_buffer_length,
+	DWORD *required_length
+);
+*/
+
+bool check_hardwareids(SP_DRVINFO_DETAIL_DATA_A *drv_info_detail_data);
+
+
+/*
+ * Helper function for transforming double zero byte terminated string array to linked_list_t
+ * @param pile                  double zero byte terminated string array
+ * @return                      linked_list_t with copied strings of the string array, heap allocated
+ */
+linked_list_t *string_array_to_linked_list(char *pile);
+
+/*
+ * Implementation of tun_device_create for Windows.
+ * @param name_tmpl     zero byte terminated string that contains the name template for the interface.
+ */
+tun_device_t *tun_device_create(const char *name_tmpl);
+
+
+#endif /* WINDOWS_TUN_H */
+
